/*
** entite.h
**
** Made by Patrick MARIE (linfg122)
** <mycroft@minithins.net> on marine.edu.ups-tlse.fr
**
** Started on  Fri Nov 08 10:59:50 2002 linfg122 
** Last update dim 24 nov 2002 18:09:50 CET mycroft
*/

/*
 * Header de entite.c
 */
#ifndef _HEADER_ENTITE_
#define _HEADER_ENTITE_

#define DEFAULT_LIFE 1000

#define DEFAULT_PT_EAT 5
#define DEFAULT_PT_MOV 3
#define DEFAULT_PT_REP 1

/* pas utilise plus longtemps */
typedef struct espece_t
{
  unsigned int t1:1;
  unsigned int t2:1;
  unsigned int t3:1;
  unsigned int t4:1;

  unsigned int t5:1;
  unsigned int t6:1;
  unsigned int t7:1;
  unsigned int t8:1;
} espece;

typedef struct entite_t 
{
  unsigned int espece;
  unsigned int x;
  unsigned int y;
  int          vie;
  int          pt_eat; /* manger */
  int          pt_mov; /* mouvemnt */
  int          pt_rep; /* repro */
  int          pt_ter;
  int          pt_med;
  int          pt_arm;
  int          pt_mut;
  int          pt_sci;
  int          pt_bra;
  int          pt_utf;
  int          pt_pmp;
  int          pt_42;
} entite, *pentite;

typedef struct objet_t
{
  unsigned int espece;
  char nom_espece[32];
  unsigned char carac;
  union
  {
    espece esp;
    int ch_esp;
  } jemange;
  union
  {
    espece esp;
    int ch_esp;
  } tumemanges; /* == JE SUIS */

  int mvt_plaine;
  int mvt_montagne;
  int mvt_eau;
  int mvt_neige;
  int mvt_foret;
  int mvt_desert;

  int pt_repro; /* Points necessaires a la reproduction */

  int max_pt_eat; /* MANGER */
    /* Manger c est clair, non ? ;-) */
  int max_pt_mov; /* BOUGER */
    /* Inclut les comportement Poursuivre et Fuire */
  int max_pt_rep; /* REPRODUIRE */
    /* Reproduction */
  int max_pt_ter; /* TERRAFORMER */
    /* Modifie le terrain de l'ou on est */
  int max_pt_med; /* MEDITER */
    /* Mediter cosiste a rien faire. */
    /* Enfin quand on medite on perd tout ses points de meditations pour les
       multiplier par 10 et on ajoute ca a la vie */
  int max_pt_arm; /* ARMAGUEDON */
    /* Si la bestiolle a moins de 25 points de vie, il lui est
       possible d'utiliser le comportement armaguedon dans quel cas
       elle se tue et elle tue toutes les bestiolles proches d'elle */
  int max_pt_mut; /* MUTATION */
    /* Se modifie en une autre espece */
    /* Perd tout ses points dans les autres actions */

  int max_pt_sci; /* SCIENCE */
    /* */
  int max_pt_bra; /* BRAILLER */
    /* */
  int max_pt_utf; /* Use the force */
    /* Se teleporte autre part sans effort */
  int max_pt_pmp; /* Pomper comme les shadocks */
    /* Ne bouge pas, ne fait rien, ne gagne pas de points de vie, mais
       rajoute un point a chaque comportement, sauf le comportement pomper */
  int max_pt_42;  /* Comportement 42 */
    /* */

} objet, *pobjet;

cel *charger_objets (const char *filename);
void libere_objets (cel *head);

cel *charger_entites (const char *filename);
void libere_entites (cel *head);

cel *creer_entites (int x, int y, cel *obj);

char get_char_espece (int esp, pcel liste_objets);
cel *retourne_objet_par_carac (cel *liste, unsigned char espece);
cel *retourne_objet_par_espece (cel *liste, unsigned int espece);
int retourne_pt_repro_par_espece (cel *liste, unsigned char espece);


#endif
