/*
** fonctions.c
**
** Made by Patrick MARIE (linfg122)
** <mycroft@minithins.net> on marine.edu.ups-tlse.fr
**
** Started on  Fri Nov 08 11:13:49 2002 linfg122
** Last update Tue Nov 19 18:45:18 2002 linfg122
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>

#include "fonctions.h"

/*
 * Compteur de nombre de malloc non libere.
 */
static int cpt_mem_pos;
static int cpt_mem_neg;
static int code_retour;

/*
 * Fonctions standards pour le debuggages.
 */

void *my_malloc (size_t size)
{
  void *buf;

  if ((buf = malloc ( size )))
    cpt_mem_pos += 1;
#ifdef DEBUG
  else
  {
    perror ("my_malloc");
    fprintf (stderr, "Erreur d'allocation de la memoire\n");
    set_return_code (E_MEMORY_ALLOC);
  }
#else
  else
  {
    set_return_code (E_MEMORY_ALLOC);
  }
#endif

  return (buf);
}

void my_free (void *buf)
{
  if (buf)
  {
    cpt_mem_neg += 1;
    free (buf);
  }
#ifdef DEBUG
  else
  {
    fprintf (stderr, "Free a recu un parametre NULL.\n");
    set_return_code (E_MEMORY_FREE);
  }
#else
  else
  {
     set_return_code (E_MEMORY_FREE);
  }
#endif

  return ;
}

void *my_getcwd (void)
{
  char *tmp;

  tmp = getcwd (NULL, PATH_MAX);
  if (tmp)
    cpt_mem_pos += 1;
  else
    set_return_code (E_GETCWD);

  return (tmp);
}

int my_memoire_status (void)
{
  return (cpt_mem_pos - cpt_mem_neg);
}

int my_memoire_reset (void)
{
  cpt_mem_pos = 0;
  cpt_mem_neg = 0;
  return (0);
}

int set_return_code (int a)
{
  code_retour = a;
  return (0);
}

int get_return_code ( void )
{ 
  return (code_retour);
}

void vide_buffer (void)
{
  while ((getchar () != '\n'));
  return ;
}

int my_getchar (void)
{
  int c;

  c = getchar (); 

  if (c != '\n')
    vide_buffer ();

  return (c);
}

int pow (int a, int b)
{
  int i;
  int r = 1;

  for (i = 0; i < b; i ++)
    r *= a;

  return (r);
}

static FILE *lalalala;

int ouvre_debug (void)
{
  /* On est en debug jvais pas non plus faire des tests pour ca quoi .. */
  unlink ("/tmp/debug.eco6tem");
  lalalala = fopen ("/tmp/debug.eco6tem", "wt+");
  return (0);
}

int ferme_debug (void)
{
  if (lalalala != NULL)
    fclose (lalalala);

  return (0);
}

int do_debug (char* fmt, ...)
{
#ifdef DEBUG
  va_list truc;

  if (lalalala != NULL)
  {
    va_start(truc, fmt);
    vfprintf (lalalala, fmt, truc);
    fflush (lalalala);
    va_end (truc);
  }
#endif
  return (0);
}
