/*
** fonctions.h
**
** Made by Patrick MARIE (linfg122)
** <mycroft@minithins.net> on marine.edu.ups-tlse.fr
**
** Started on  Fri Nov 08 11:14:10 2002 linfg122
** Last update sam 23 nov 2002 19:16:58 CET mycroft
*/

#ifndef HEADER_FONCTIONS
#define HEADER_FONCTIONS
/*
 * Header du fichier fonctions.c
 */

#ifndef PATH_MAX
#define PATH_MAX 2048
#endif
#define TAB_MAX 1024

#include <stdlib.h>

#define E_OK 0
#define E_FICHIER_ENTITE 1
#define E_FICHIER_MONDE 2 
#define E_INPUT_OUTPUT 3

#define E_YAPLUSDEBESTIOLLE 4
#define E_NAPASPLUSDEMARRER_LE_JEU 5

#define E_FICHIER_OBJETS_NON_CHARGE 6
#define E_BAD_USER 7
#define E_BAD_CODER 8

#define E_MEMORY_ALLOC 9
#define E_MEMORY_FREE 10

#define E_GETCWD 11
#define E_FICHIER_OBJET 12 
#define E_LISTE_PASTROUVE 13
#define E_TERRAIN_MAL_FORME 14

#define E_PASDEPARTIES 15

/*
 * Fonctions ordinaires de gestion de memoire
 */
extern void *my_malloc (size_t size);
extern void my_free (void *buf);
extern void *my_getcwd (void);

/* Renvoit le nombre de buffer malloces non free(2) */
int my_memoire_status (void);

/* Pour viter les soucis avec les buffers et tout ca */
void vide_buffer (void);
int my_getchar (void);

int get_return_code (void);
void vide_buffer (void);

int set_return_code (int codederreur);
int get_return_code (void);

int pow (int a, int b);

int ouvre_debug (void);
int ferme_debug (void);
int do_debug (char * fmt, ...);

#endif 
