/*
** listes.c
**
** Made by Patrick MARIE (linfg122)
** <mycroft@minithins.net> on marine.edu.ups-tlse.fr
**
** Started on  Fri Nov 08 10:57:15 2002 linfg122
** Last update ven 22 nov 2002 22:00:39 CET mycroft
*/

/*
 * Fonctions relatives aux listes chaines.
 */

#include <stdlib.h>

#include "fonctions.h"
#include "listes.h"

cel *creer_liste (void)
{
  return (NULL);
}

cel *creer_cel (void *info)
{
  cel *tmp;

  tmp = my_malloc (sizeof (cel));
  if (!tmp)
    return (NULL); 

  tmp->cel_suiv = NULL;
  tmp->cel_info = info;

  return (tmp);
}

int vider_liste (cel **liste)
{
  cel *tmp ;

  if (!*liste)
    return (1);

  do
  {
    tmp = *liste;
    *liste = tmp->cel_suiv;
    if (tmp->cel_info)
      my_free (tmp->cel_info); 
    my_free (tmp);
  }
  while (*liste);

  return (0);
}

int virer_liste (cel **liste, cel *el)
{
  cel *tmp = *liste;
  cel *avant_tmp = NULL;

  while (tmp != el && tmp)
  {
    avant_tmp = tmp;
    tmp = CEL_NEXT(tmp);
  }

  if (tmp)
  {
    if (avant_tmp) 
      CEL_NEXT(avant_tmp) = CEL_NEXT(CEL_NEXT(avant_tmp));
    else
    {
      *liste = CEL_NEXT(*liste);
      avant_tmp = *liste;
    }

    /* on vire el de la memoire tout ca */
    if (CEL_CONT(el))
      my_free (CEL_CONT(el));
    my_free (el);
    return (0);
  }

  set_return_code (E_LISTE_PASTROUVE);

  /* cas improbable */
  return (-1);
}

int ajout_liste (cel **liste, void *info)
{
  cel *new = creer_cel (info);
  if (!new)
    return (-1);

  new->cel_suiv = *liste;
  *liste = new;
 
  return (0);
}
