/*
** listes.h
**
** Made by Patrick MARIE (linfg122)
** <mycroft@minithins.net> on marine.edu.ups-tlse.fr
**
** Started on  Fri Nov 08 10:57:29 2002 linfg122
** Last update ven 22 nov 2002 22:00:44 CET mycroft
*/

/*
 * Header du fichier listes.c
 */

#ifndef _LISTES_HEADER_
#define _LISTES_HEADER_

typedef struct cel_t
{
  struct cel_t *cel_suiv;
  void *cel_info;
} cel, *pcel;

#define CEL_NEXT(tmp) ((tmp)->cel_suiv)
#define CEL_CONT(tmp) ((tmp)->cel_info)

/* Creer un debut de liste vide */
/* aka renvoit NULL */
cel *creer_liste (void);

/* Creer une cellule et remplis les chans */
cel *creer_cel (void *info);

/* Vide une liste tout entiere */
/* Si pour chaque element il existe un chan info,
   il le free(2) */
/* Renvoit 0 si il a efface la liste */
/* Renvoit 1 si la liste etait vide */
int vider_liste (cel **liste);

/* Rajoute a la liste 'liste' l element 'info' */
/* Renvoit 0 si tout est ok */
/* Renvoit -1 si il y a eu un probleme */
int ajout_liste (cel **liste, void *info);

/* Retirer un elemeent de la liste */
int virer_liste (cel **liste, cel *el);

#endif
