/*
** monde.h
**
** Made by Patrick MARIE (linfg122)
** <mycroft@minithins.net> on marine.edu.ups-tlse.fr
**
** Started on  Fri Nov 08 10:56:56 2002 linfg122
** Last update Fri Nov 22 10:40:56 2002 linfg122
*/
#ifndef _HEADER_MONDE_
#define _HEADER_MONDE_

/*
 * Header du fichier monde.c
 */

#define MAX_WORLD_SIZE 1024

/*
 * Le monde est constitue d'une matrice.
 */

typedef struct monde_t
{
  unsigned int taille_x; /* taille horizontale */
  unsigned int taille_y; /* taille verticale */
  unsigned char *tabland; /* tableau compose du type de terrain */
                         /* ce tableau est fixe, defini une fois pour toutes */
  unsigned int cycle;    /* cycle ou le monde se situe. */
  unsigned char *tabgfx; /* tableau contenant a chaque cycle letat graphique du jeu */
  unsigned int past;
  unsigned int present;
  unsigned int future;

} monde, *pmonde;

/*
Types de terrains:
 .  - normal, plaine
 ^  - montagne
 ~  - mer
 _  - sableuh
 *  - neige/toundra
 #  - buissons, foret
 */

struct monde_t *charger_monde (const char *fichier_monde);
int libere_monde (struct monde_t *monde);
struct monde_t *creer_monde (void);

#endif
