#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include "listes.h"
#include "fonctions.h"
#include "entite.h"
#include "monde.h"
#include "regarde.h"

/* Renvoit 1 si ent1 doit manger ent2 */
int compare_sijedoismanger (pcel ent1, pcel ent2, unsigned int vie1, unsigned int vie2)
{
  if (
  (((struct objet_t*)CEL_CONT(ent1))->jemange.esp.t1 && ((struct objet_t*)CEL_CONT(ent2))->tumemanges.esp.t1)
  || (((struct objet_t*)CEL_CONT(ent1))->jemange.esp.t2 && ((struct objet_t*)CEL_CONT(ent2))->tumemanges.esp.t2)
  || (((struct objet_t*)CEL_CONT(ent1))->jemange.esp.t3 && ((struct objet_t*)CEL_CONT(ent2))->tumemanges.esp.t3)
  || (((struct objet_t*)CEL_CONT(ent1))->jemange.esp.t4 && ((struct objet_t*)CEL_CONT(ent2))->tumemanges.esp.t4)
  || (((struct objet_t*)CEL_CONT(ent1))->jemange.esp.t5 && ((struct objet_t*)CEL_CONT(ent2))->tumemanges.esp.t5)
  || (((struct objet_t*)CEL_CONT(ent1))->jemange.esp.t6 && ((struct objet_t*)CEL_CONT(ent2))->tumemanges.esp.t6)
  || (((struct objet_t*)CEL_CONT(ent1))->jemange.esp.t7 && ((struct objet_t*)CEL_CONT(ent2))->tumemanges.esp.t7)
  || (((struct objet_t*)CEL_CONT(ent1))->jemange.esp.t8 && ((struct objet_t*)CEL_CONT(ent2))->tumemanges.esp.t8)
  )
	if (vie1 >= vie2)
      return (1);

  return (0);
}

int compare_sijemefaismangerpar (pcel ent1, pcel ent2, unsigned int vie1, unsigned int vie2)
{
  return (compare_sijedoismanger(ent2, ent1, vie1, vie2));
}

/* Renvoit 0 si il n a pas trouve, sinon il renvoit 1
 */
int regarde_au_loin (
              pcel liste_objets,
              pcel liste_entites,
              struct monde_t *monde,
              pcel src_entite,
              pcel *dst_entite,
              int nombre_autour,
              int (*fonction_comparaison)(pcel,pcel,unsigned int,unsigned int))
{
  /*int i, j;*/
  pcel tmpcel;

  unsigned int debut_x, fin_x;
  unsigned int debut_y, fin_y;

  pcel src_type_objet;
  pcel tmp_type_objet;

  src_type_objet = retourne_objet_par_espece (
                 liste_objets, 
                 ((struct entite_t*)CEL_CONT(src_entite))->espece
                  );
  *dst_entite = NULL;

  debut_x = ((((struct entite_t*)CEL_CONT(src_entite))->x - nombre_autour)>0)?
             (((struct entite_t*)CEL_CONT(src_entite))->x - nombre_autour):0;

  fin_x = ((((struct entite_t*)CEL_CONT(src_entite))->x + nombre_autour)>monde->taille_x)?
           monde->taille_x:(((struct entite_t*)CEL_CONT(src_entite))->x + nombre_autour);
  fin_x --;

  debut_y = ((((struct entite_t*)CEL_CONT(src_entite))->y - nombre_autour)>0)?
             (((struct entite_t*)CEL_CONT(src_entite))->y - nombre_autour):0;

  fin_y = ((((struct entite_t*)CEL_CONT(src_entite))->y + nombre_autour)>monde->taille_y)?
           monde->taille_y:(((struct entite_t*)CEL_CONT(src_entite))->y + nombre_autour);
  fin_y --;


  tmpcel = liste_entites;
  while (tmpcel)
  {
    tmp_type_objet = retourne_objet_par_espece
      (liste_objets, ((struct entite_t*)CEL_CONT(tmpcel))->espece);

    if (tmpcel != src_entite)
    if (
         ((struct entite_t*)CEL_CONT(tmpcel))->x >= debut_x
         && ((struct entite_t*)CEL_CONT(tmpcel))->x <= fin_x
         && ((struct entite_t*)CEL_CONT(tmpcel))->y >= debut_y
         && ((struct entite_t*)CEL_CONT(tmpcel))->y <= fin_y
       )
    {
      if (fonction_comparaison (src_type_objet, tmp_type_objet, ((struct entite_t*)CEL_CONT(src_entite))->vie, ((struct entite_t*)CEL_CONT(tmpcel))->vie))
      {
        /* Ok, ici il y a un dilemne. */
        /* On va dire que je prends le plus pres */
        /* XXX a faire un test .. un jour :-)*/
        *dst_entite = tmpcel;
      }
    }

    tmpcel = CEL_NEXT(tmpcel);
  }

  if (*dst_entite)
    return (1);
  else
    return (0);

  /* Ne peut pas arriver */
  return (-1);
}

int est_ce_une_case_libre (struct monde_t *monde, pcel liste_entites, 
                           int x, int y)
{
  pcel cel_actual = liste_entites;

  if (x < monde->taille_x && x > 0 && y < monde->taille_y && y > 0)
  {
    while (cel_actual)
    {
      if (
        ((struct entite_t*)CEL_CONT(cel_actual))->x == x
        && ((struct entite_t*)CEL_CONT(cel_actual))->y == y
        ) return (0);
      cel_actual = CEL_NEXT (cel_actual);
    }
    return (1);
  }
  return (0);
}

int cherche_pour_une_case_ou_fuire (struct monde_t *monde, pcel liste_entites,
                                    int x, int y, int evil_x, int evil_y,
                                    int *dst_x, int *dst_y)
{ /* On fait les 8 cases adjacantes, jusqua en trouver une ou la distance
     soit la plus grande ... */
  int i, j;
  int max_dist_found = -1;

  int tmp_x = -1;
  int tmp_y = -1;
  int tmp_dist = -1;

  for (i = -1; i < 2; i ++)
  {
    for (j = -1; j < 2; j ++)
    {
      if (x + i < monde->taille_x && x + i > 0
       && y + j < monde->taille_y && y + j > 0)
      {
        /* Ok, we're in the grid */
        if (est_ce_une_case_libre(monde, liste_entites, x + i, y + j))
        {
          /* Ok, la case est libre, alors on la prend si la distance est +
             grande */
          tmp_x = (x + i) - evil_x;
          tmp_y = (y + j) - evil_y;
          tmp_dist = tmp_x * tmp_x + tmp_y * tmp_y;

          if (tmp_dist > max_dist_found)
          { /* Huh ! On prend ! */
            max_dist_found = tmp_dist;
            *dst_x = i;
            *dst_y = j;
          }
        }
      }
    }
  }

  if (max_dist_found != -1)
    return (1);

  return (0);
}

/* Cette fonction est trop pas utile en fait .... */
int cherche_pour_une_case_ou_manger (struct monde_t *monde, pcel liste_entites,
                                     int x, int y, int evil_x, int evil_y,
                                     int *dst_x, int *dst_y)
{
  int i, j;
  /* C est max, du au copier/coller avec au dessus, mais en fait c est min */
  int max_x = -1;
  int max_y = -1;
  int max_dist_found = 100000;

  int tmp_x = -1;
  int tmp_y = -1;
  int tmp_dist = -1;

  for (i = -1; i < 2; i ++)
  {
    for (j = -1; j < 2; j ++)
    {
      if (x + i < monde->taille_x && x + i > 0
       && y + j < monde->taille_y && y + j > 0)
      {
        /* Ok, we're in the grid */
        if (est_ce_une_case_libre(monde, liste_entites, x + i, y + j))
        {
          /* Ok, la case est libre, alors on la prend si la distance est +
             petite */
          tmp_x = (x + i) - evil_x;
          tmp_y = (y + j) - evil_y;
          tmp_dist = tmp_x * tmp_x + tmp_y * tmp_y;
          if (tmp_dist < max_dist_found)
          { /* Huh ! On prend ! */
            max_dist_found = tmp_dist;
            max_x = i;
            max_y = j;
          }
        }
      }
    }
  }

  *dst_x = max_x;
  *dst_y = max_y;

  if (max_dist_found != -1)
    return (1);

  return (0);
}

int sort_une_case_adj_au_pif (int *x, int *y)
{
  struct timeval test;

  gettimeofday (&test, NULL);
  srand (test.tv_usec);
  
  *x = (rand () % 3) - 1;
  *y = (rand () % 3) - 1;

  return (0);
}
