/*
** vie.c
**
** Made by mycroft (mycroft)
** <mycroft@minithins.net> on death.minithins.net
**
** Started on  sam 23 nov 2002 17:40:28 CET mycroft
** Last update sam 23 nov 2002 21:52:36 CET mycroft
*/

#include <stdio.h>
#include <sys/time.h>

#include "listes.h"
#include "fonctions.h"
#include "entite.h"
#include "monde.h"
#include "regarde.h"
#include "vie.h"

int reset_compteur (pcel liste_objets, pcel truc)
{
  pcel temp = retourne_objet_par_espece 
      (liste_objets, ((struct entite_t *)CEL_CONT(truc))->espece);

  if (!temp)
    return (-1);

  if (((struct entite_t*)CEL_CONT(truc))->vie > 1000)
    ((struct entite_t*)CEL_CONT(truc))->vie = 1000;

  ((struct entite_t*)CEL_CONT(truc))->pt_eat 
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_eat;

  ((struct entite_t*)CEL_CONT(truc))->pt_mov 
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_mov;

  ((struct entite_t*)CEL_CONT(truc))->pt_rep 
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_rep;

  ((struct entite_t*)CEL_CONT(truc))->pt_med
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_med;

  ((struct entite_t*)CEL_CONT(truc))->pt_arm
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_arm;

  ((struct entite_t*)CEL_CONT(truc))->pt_mut
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_mut;

  ((struct entite_t*)CEL_CONT(truc))->pt_ter
    = ((struct objet_t *)CEL_CONT(temp))->max_pt_ter;

  ((struct entite_t*)CEL_CONT(truc))->pt_sci
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_sci;

  ((struct entite_t*)CEL_CONT(truc))->pt_bra
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_bra;

  ((struct entite_t*)CEL_CONT(truc))->pt_utf
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_utf;

  ((struct entite_t*)CEL_CONT(truc))->pt_pmp
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_pmp;

  ((struct entite_t*)CEL_CONT(truc))->pt_42
     = ((struct objet_t *)CEL_CONT(temp))->max_pt_42;

  return 0;
}

int jebougejebouge (struct monde_t **monde, cel **entites, pcel liste_objets,
                    pcel cel_actual, int x, int y)
{
  pcel temp ;
  int rajoute = 0;

  if (x == 0 || y == 0)
     rajoute = 10;
  else
    rajoute = 14;

  if (est_ce_une_case_libre (*monde, *entites,
     ((struct entite_t *)CEL_CONT(cel_actual))->x + x,
     ((struct entite_t *)CEL_CONT(cel_actual))->y + y)
     )
  {
    ((struct entite_t *)CEL_CONT(cel_actual))->x += x;
    ((struct entite_t *)CEL_CONT(cel_actual))->y += y;

    temp = retourne_objet_par_espece (liste_objets, ((struct entite_t *)CEL_CONT(cel_actual))->espece);

    switch (*((*monde)->tabland + x + (y * (*monde)->taille_x)))
    {
      case '.':
        ((struct entite_t *)CEL_CONT(cel_actual))->vie
          -= ((struct objet_t *)CEL_CONT(temp))->mvt_plaine;
      break;
      case '^':
        ((struct entite_t *)CEL_CONT(cel_actual))->vie
          -= ((struct objet_t *)CEL_CONT(temp))->mvt_montagne;
      break;
      case '~':
        ((struct entite_t *)CEL_CONT(cel_actual))->vie
          -= ((struct objet_t *)CEL_CONT(temp))->mvt_eau;
      break;
      case '_':
        ((struct entite_t *)CEL_CONT(cel_actual))->vie
          -= ((struct objet_t *)CEL_CONT(temp))->mvt_desert;
      break;
      case '*':
        ((struct entite_t *)CEL_CONT(cel_actual))->vie
          -= ((struct objet_t *)CEL_CONT(temp))->mvt_neige;
      break;
      case '#':
        ((struct entite_t *)CEL_CONT(cel_actual))->vie
          -= ((struct objet_t *)CEL_CONT(temp))->mvt_foret;
      break;
      default:
        /* Strange. */
        ((struct entite_t *)CEL_CONT(cel_actual))->vie -= 5;
      break;
    }
    ((struct entite_t *)CEL_CONT(cel_actual))->vie -= rajoute;

    ((struct entite_t *)CEL_CONT(cel_actual))->pt_mov --;
  }
  else
    return (-1);

  return (0);
}


/*
 * Utilisation du tour par tour.
 *
 */

int new_world (struct monde_t **monde, cel **entites, pcel liste_objets)
{
  pcel cel_actual = *entites;
  pcel cel_next_to_interact = NULL;
  pcel dst_entite;
  pcel tmp_cel;
  int move;
  int r;
  int x = 0, y = 0;
  int jaibouge;
  int cpt;
  int jairienfait;
  int tmp_cpt;
  struct timeval test;
  struct entite_t *el;
  char tmp_char;
  unsigned int debut_x, fin_x;
  unsigned int debut_y, fin_y;
  int nombre_autour;

  if (!*entites)
  {
    /* No more entities */
    fprintf (stderr, "Il semble que le monde n'est plus aucune entite.\n");
    return (-1); 
  }

#ifdef DEBUG
  do_debug ("\n\n**** CYCLE %i ****\n", (*monde)->cycle);

  cel_actual = *entites;
  while (cel_actual)
  { 
    do_debug ("%p: %i x:%i y:%i vie:%i  %i %i %i %i %i %i %i %i %i %i %i %i\n",
    cel_actual,
    ((struct entite_t*)CEL_CONT(cel_actual))->espece,
    ((struct entite_t*)CEL_CONT(cel_actual))->x,
    ((struct entite_t*)CEL_CONT(cel_actual))->y,
    ((struct entite_t*)CEL_CONT(cel_actual))->vie,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_eat,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_mov,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_rep,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_ter,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_med,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_arm,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_mut,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_sci,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_bra,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_utf,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_pmp,
    ((struct entite_t*)CEL_CONT(cel_actual))->pt_42);
    cel_actual = CEL_NEXT (cel_actual);
  }
#endif

  if (!((*monde)->cycle % 10) || (*monde)->cycle == 1)
  { /* C'est l'heure de remontre les compteurs a 0 */
    cel_actual = *entites;
    while (cel_actual)
    {
      reset_compteur (liste_objets, cel_actual);
      cel_actual = CEL_NEXT (cel_actual);
    }
  }

  do /* Boucle Principale */
  {
    if (cel_next_to_interact)
      cel_actual = cel_next_to_interact;
    else
      cel_actual = *entites;

    cel_next_to_interact = CEL_NEXT (cel_actual);

    /*
     * A ce moment precis, on a pleins de choses a faire.
     */

    /*
     * On regarde si il n'y a pas un truc qui peut nous manger. 
     */

    jaibouge = 0;

    if (((struct entite_t*)CEL_CONT(cel_actual))->pt_mov > 0)
    {
      jaibouge = 1;
      r = regarde_au_loin (liste_objets, *entites, *monde,
                           cel_actual, &dst_entite, LEN_VUE, 
                           compare_sijemefaismangerpar); 
      if ( r )
      { /* Faut que je me casse */
        if (cherche_pour_une_case_ou_fuire (*monde, *entites, 
             ((struct entite_t*)CEL_CONT(cel_actual))->x,
             ((struct entite_t*)CEL_CONT(cel_actual))->y,
             ((struct entite_t*)CEL_CONT(dst_entite))->x,
             ((struct entite_t*)CEL_CONT(dst_entite))->y,
             &x, &y))
        {
#ifdef DEBUG
          do_debug ("%p fuit en (ox:%i oy:%i) x:%i y:%i\n", cel_actual,
                    ((struct entite_t*)CEL_CONT(cel_actual))->x,
                    ((struct entite_t*)CEL_CONT(cel_actual))->y,
                    x, y
                   );
#endif
          jebougejebouge (monde, entites, liste_objets, cel_actual, x, y);
         }
      }
      else
      { /* Pas d ennemi en vue, je regarde si il y a pas de quoi manger
           a _cote_ */
        r = regarde_au_loin (liste_objets, *entites, *monde,
                             cel_actual, &dst_entite, 1,
                             compare_sijedoismanger);
        if ( r )
        { /* Y a qqun a bouffer */
#ifdef DEBUG
          do_debug ("%p mange %p\n",cel_actual, &dst_entite);
#endif
          ((struct entite_t*)CEL_CONT(cel_actual))->vie
            += ((struct entite_t*)CEL_CONT(dst_entite))->vie;
          if (((struct entite_t*)CEL_CONT(cel_actual))->vie > 1000)
            ((struct entite_t*)CEL_CONT(cel_actual))->vie = 1000;

          /* On retire dst_entite de la liste chainee. Paix a son ame */

          tmp_cel = CEL_NEXT (dst_entite);

          if (dst_entite == cel_next_to_interact)
            cel_next_to_interact = tmp_cel;

          virer_liste (entites, dst_entite);

          dst_entite = tmp_cel;

          ((struct entite_t*)CEL_CONT(cel_actual))->pt_eat --;
        }
        else
        { /* Faut que je me bouge, vers qqchose a manger */
          r = regarde_au_loin (liste_objets, *entites, *monde,
                               cel_actual, &dst_entite, LEN_VUE,
                               compare_sijedoismanger);
          if ( r )
          { /* On mange */
            if(cherche_pour_une_case_ou_manger (*monde, *entites,
               ((struct entite_t*)CEL_CONT(cel_actual))->x,
               ((struct entite_t*)CEL_CONT(cel_actual))->y,
               ((struct entite_t*)CEL_CONT(dst_entite))->x,
               ((struct entite_t*)CEL_CONT(dst_entite))->y,
               &x, &y))
            {
#ifdef DEBUG
          do_debug ("%p poursuit en (ox:%i oy:%i) x:%i y:%i\n", cel_actual,
                    ((struct entite_t*)CEL_CONT(cel_actual))->x,
                    ((struct entite_t*)CEL_CONT(cel_actual))->y,
                    x, y
                   );
#endif
              jebougejebouge (monde, entites, liste_objets, cel_actual, x, y);
            }
          }
          else
          {
            jaibouge = 0;
          }
        }
      }
    } /* Fin si il me reste des points mouvements */

    /* Si jai pas bouge a cause des mes instincts naturels :
       - me faire bouffer
       - bouffer
       - partir chasser la bouffe
       - etc etc etc
      */

    if (!jaibouge)
    {
      /* J'ai le choix entre 12 comportements */

      cpt = 0;
      jairienfait = 1;

      gettimeofday (&test, NULL);
      srand (test.tv_usec);

      do
      {
        int u;
        u = 2 + rand() % 7;

        switch (u)
        {
          case 1: /* Comportement MANGER */
            /* Deja gere autre part, on passe */
          break;

          case 2: /* Comportement BOUGER */ 
            if (((struct entite_t*)CEL_CONT(cel_actual))->pt_mov > 0)
            {
              move = 0;
              tmp_cpt = 0;
              do
              {
                sort_une_case_adj_au_pif (&x, &y);
                if (!jebougejebouge 
                           (monde, entites, liste_objets, cel_actual, x, y))
                {
#ifdef DEBUG
          do_debug ("%p a bouge en x:%i y:%i\n", cel_actual,
                    ((struct entite_t*)CEL_CONT(cel_actual))->x,
                    ((struct entite_t*)CEL_CONT(cel_actual))->y
                   );
#endif
                  move = 1;
                }
                else
                  tmp_cpt ++;
              }
              while (!move && tmp_cpt < 5);
  
              if (move) /* jai bouge ... */
                jairienfait = 0;
            }
          break;

          case 3: /* REPRODUIRE */
            if (((struct entite_t*)CEL_CONT(cel_actual))->pt_rep > 0)
            {
              if (((struct entite_t*)CEL_CONT(cel_actual))->vie > 
                retourne_pt_repro_par_espece (liste_objets, ((struct entite_t*)CEL_CONT(cel_actual))->espece))
              {
                sort_une_case_adj_au_pif (&x, &y);

                if (x != 0 && y != 0 
                    && est_ce_une_case_libre (*monde, *entites, ((struct entite_t*)CEL_CONT(cel_actual))->x + x, ((struct entite_t*)CEL_CONT(cel_actual))->y + y))
                {
                  el = my_malloc (sizeof (struct entite_t));
                  if (el)
                  {
                    el->espece = ((struct entite_t*)CEL_CONT(cel_actual))->espece;
                    el->x = ((struct entite_t*)CEL_CONT(cel_actual))->x + x;
                    el->y = ((struct entite_t*)CEL_CONT(cel_actual))->y + y;
                    el->vie = ((struct entite_t*)CEL_CONT(cel_actual))->vie / 3;
                    ((struct entite_t*)CEL_CONT(cel_actual))->vie -= el->vie; 

                    el->pt_eat = 0; el->pt_mov = 0;
                    el->pt_rep = 0; el->pt_ter = 0;
                    el->pt_med = 0; el->pt_arm = 0;
                    el->pt_mut = 0; el->pt_sci = 0;
                    el->pt_bra = 0; el->pt_utf = 0;
                    el->pt_pmp = 0; el->pt_42 = 0; 

                    ajout_liste (entites, el);
                    ((struct entite_t*)CEL_CONT(cel_actual))->pt_rep --;
#ifdef DEBUG 
                    do_debug ("%p vient de se reproduire.\n",cel_actual);
#endif
                    jairienfait = 0;
                  }
                }
              }
            }
          break;
          case 4: /* TERRAFORMER */
            if (((struct entite_t*)CEL_CONT(cel_actual))->pt_ter > 0)
            {
              tmp_char = 0;
              gettimeofday (&test, NULL);
              srand (test.tv_usec);

              switch (rand () % 6)
              {
                case 0: tmp_char = '.'; break;
                case 1: tmp_char = '^'; break;
                case 2: tmp_char = '~'; break;
                case 3: tmp_char = '_'; break;
                case 4: tmp_char = '*'; break;
                case 5: tmp_char = '#'; break;
              }

              *((*monde)->tabland + ((struct entite_t*)CEL_CONT(cel_actual))->x + (((struct entite_t*)CEL_CONT(cel_actual))->y * (*monde)->taille_x)) = tmp_char;

              ((struct entite_t*)CEL_CONT(cel_actual))->pt_ter --;
#ifdef DEBUG 
              do_debug ("%p vient de terraformer.\n", cel_actual);
#endif
              jairienfait = 0;
            }
          break;

          case 5: /* MEDITER */
            if (((struct entite_t*)CEL_CONT(cel_actual))->pt_med > 0)
            {
              ((struct entite_t*)CEL_CONT(cel_actual))->vie +=
                ((struct entite_t*)CEL_CONT(cel_actual))->pt_med * 10;
              jairienfait = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_med = 0;
#ifdef DEBUG 
              do_debug ("%p vient de mediter.\n", cel_actual);
#endif
              jairienfait = 0;
            }
          break;
          case 6: /* ARMAGUEDON */
            if (((struct entite_t*)CEL_CONT(cel_actual))->pt_arm > 0)
            {
              if (((struct entite_t*)CEL_CONT(cel_actual))->vie <= 25)
              {
                nombre_autour = 5;

                debut_x = ((((struct entite_t*)CEL_CONT(cel_actual))->x - nombre_autour)>0)?
                  (((struct entite_t*)CEL_CONT(cel_actual))->x - nombre_autour):0;

                fin_x = ((((struct entite_t*)CEL_CONT(cel_actual))->x + nombre_autour)>(*monde)->taille_x)?
                  (*monde)->taille_x:(((struct entite_t*)CEL_CONT(cel_actual))->x + nombre_autour);
                fin_x --;

                debut_y = ((((struct entite_t*)CEL_CONT(cel_actual))->y - nombre_autour)>0)?
                  (((struct entite_t*)CEL_CONT(cel_actual))->y - nombre_autour):0;

                fin_y = ((((struct entite_t*)CEL_CONT(cel_actual))->y + nombre_autour)>(*monde)->taille_y)?
                  (*monde)->taille_y:(((struct entite_t*)CEL_CONT(cel_actual))->y + nombre_autour);
                fin_y --;

                dst_entite = *entites;
                while (dst_entite)
                {
                  if (
                    ((struct entite_t*)CEL_CONT(dst_entite))->x >= debut_x
                 && ((struct entite_t*)CEL_CONT(dst_entite))->x <= fin_x
                 && ((struct entite_t*)CEL_CONT(dst_entite))->y >= debut_y
                 && ((struct entite_t*)CEL_CONT(dst_entite))->y <= fin_y
                     )
                  {
                    tmp_cel = CEL_NEXT (dst_entite);

                    if (dst_entite == cel_next_to_interact)
                      cel_next_to_interact = tmp_cel; 

                    virer_liste (entites, dst_entite);

                    dst_entite = tmp_cel; 
                  }
                  else
                    dst_entite = CEL_NEXT(dst_entite);
                } /* fin while */

#ifdef DEBUG
                do_debug ("armeguedon !\n");
#endif
                jairienfait = 0;
              }
            }
          break;

          case 7: /* MUTATION */
            if (((struct entite_t*)CEL_CONT(cel_actual))->pt_mut > 0)
            {
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_eat = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_mov = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_rep = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_med = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_arm = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_mut = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_sci = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_bra = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_utf = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_pmp = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_42 = 0;

              gettimeofday (&test, NULL);
              srand (test.tv_usec);

              tmp_char = ((1 + rand () % 7));
              ((struct entite_t*)CEL_CONT(cel_actual))->espece = pow(2, tmp_char);

#ifdef DEBUG
              do_debug ("%p vient de mutter.\n", cel_actual);
#endif
              jairienfait = 0;
            }
          break;
              
          case 11: /* SCIENCE */
            jairienfait = 0;
          break;
         
          case 9: /* BRAILLER */
            jairienfait = 0;
          break;
          case 10: /* Use the force */
            jairienfait = 0;
          break;
          case 8: /* Pomper comme les shadocks */
            if (((struct entite_t*)CEL_CONT(cel_actual))->pt_mut > 0)
            {
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_eat ++ ;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_mov ++ ;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_rep ++ ;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_med ++ ;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_arm ++ ;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_mut ++ ;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_sci ++ ;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_bra ++ ;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_utf ++ ;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_pmp = 0;
              ((struct entite_t*)CEL_CONT(cel_actual))->pt_42 ++;
#ifdef DEBUG
              do_debug ("%p vient de pomper comme un shadok.\n", cel_actual);
#endif
              jairienfait = 0;
            }
          break;
          case 12: /* Comportement 42 */
            jairienfait = 0;
          break;

        }
        cpt ++;
      }
      while (cpt != 64 && jairienfait);

      if (jairienfait)
      {
        /* Bah je dors alors ... */
        ((struct entite_t*)CEL_CONT(cel_actual))->vie += 10;
#ifdef DEBUG
        do_debug ("%p ne fait rien. Oui, rien.\n", cel_actual); 
#endif
      }

    }
  /* L'indentation est correcte */
  }
  while (cel_next_to_interact);

  return (0);
}
